您有一个想通过编写 Bash 脚本解决的问题。不幸的是,您不太清楚从哪里开始。一种方法是直接投入并编写脚本中容易的部分,并将困难的部分写成 伪代码。
#!/bin/bash ARGCOUNT=1 # Need name as argument. E_WRONGARGS=65 if [ number-of-arguments is-not-equal-to "$ARGCOUNT" ] # ^^^^^^^^^^^^^^^^^^^ ^^^^^^^^^^^^^^^ # Can't figure out how to code this . . . #+ . . . so write it in pseudo-code. then echo "Usage: name-of-script name" # ^^^^^^^^^^^^^^ More pseudo-code. exit $E_WRONGARGS fi . . . exit 0 # Later on, substitute working code for the pseudo-code. # Line 6 becomes: if [ $# -ne "$ARGCOUNT" ] # Line 12 becomes: echo "Usage: `basename $0` name" |
有关使用伪代码的示例,请参见平方根练习。
要记录在特定会话期间或多个会话中运行了哪些用户脚本,请将以下行添加到您要跟踪的每个脚本中。这将持续记录脚本名称和调用时间的文件记录。
# Append (>>) following to end of each script tracked. whoami>> $SAVE_FILE # User invoking the script. echo $0>> $SAVE_FILE # Script name. date>> $SAVE_FILE # Date and time. echo>> $SAVE_FILE # Blank line as separator. # Of course, SAVE_FILE defined and exported as environmental variable in ~/.bashrc #+ (something like ~/.scripts-run) |
>> 运算符将行追加到文件。如果您希望将行前置到现有文件,即将其粘贴在开头,该怎么办?
file=data.txt title="***This is the title line of data text file***" echo $title | cat - $file >$file.new # "cat -" concatenates stdout to $file. # End result is #+ to write a new file with $title appended at *beginning*. |
shell 脚本可以充当另一个 shell 脚本、Tcl 或 wish 脚本,甚至 Makefile 中的嵌入式命令。可以使用 C 程序中的外部 shell 命令调用它,使用system()调用,即,system("script_name");.
将变量设置为嵌入式 sed 或 awk 脚本的内容可以提高周围 shell 包装器的可读性。请参见 示例 A-1 和 示例 15-20。
将包含您最喜欢和最有用的定义和函数的文件放在一起。必要时,使用 点 (.) 或 source 命令将一个或多个这些“库文件”“包含”在脚本中。
# SCRIPT LIBRARY # ------ ------- # Note: # No "#!" here. # No "live code" either. # Useful variable definitions ROOT_UID=0 # Root has $UID 0. E_NOTROOT=101 # Not root user error. MAXRETVAL=255 # Maximum (positive) return value of a function. SUCCESS=0 FAILURE=-1 # Functions Usage () # "Usage:" message. { if [ -z "$1" ] # No arg passed. then msg=filename else msg=$@ fi echo "Usage: `basename $0` "$msg"" } Check_if_root () # Check if root running script. { # From "ex39.sh" example. if [ "$UID" -ne "$ROOT_UID" ] then echo "Must be root to run this script." exit $E_NOTROOT fi } CreateTempfileName () # Creates a "unique" temp filename. { # From "ex51.sh" example. prefix=temp suffix=`eval date +%s` Tempfilename=$prefix.$suffix } isalpha2 () # Tests whether *entire string* is alphabetic. { # From "isalpha.sh" example. [ $# -eq 1 ] || return $FAILURE case $1 in *[!a-zA-Z]*|"") return $FAILURE;; *) return $SUCCESS;; esac # Thanks, S.C. } abs () # Absolute value. { # Caution: Max return value = 255. E_ARGERR=-999999 if [ -z "$1" ] # Need arg passed. then return $E_ARGERR # Obvious error value returned. fi if [ "$1" -ge 0 ] # If non-negative, then # absval=$1 # stays as-is. else # Otherwise, let "absval = (( 0 - $1 ))" # change sign. fi return $absval } tolower () # Converts string(s) passed as argument(s) { #+ to lowercase. if [ -z "$1" ] # If no argument(s) passed, then #+ send error message echo "(null)" #+ (C-style void-pointer error message) return #+ and return from function. fi echo "$@" | tr A-Z a-z # Translate all passed arguments ($@). return # Use command substitution to set a variable to function output. # For example: # oldvar="A seT of miXed-caSe LEtTerS" # newvar=`tolower "$oldvar"` # echo "$newvar" # a set of mixed-case letters # # Exercise: Rewrite this function to change lowercase passed argument(s) # to uppercase ... toupper() [easy]. } |
使用专门用途的注释标头来提高脚本的清晰度和可读性。
## Caution. rm -rf *.zzy ## The "-rf" options to "rm" are very dangerous, ##+ especially with wild cards. #+ Line continuation. # This is line 1 #+ of a multi-line comment, #+ and this is the final line. #* Note. #o List item. #> Another point of view. while [ "$var1" != "end" ] #> while test "$var1" != "end" |
Dotan Barak 贡献了脚本中 进度条的模板代码。
示例 36-17. 进度条
#!/bin/bash # progress-bar.sh # Author: Dotan Barak (very minor revisions by ABS Guide author). # Used in ABS Guide with permission (thanks!). BAR_WIDTH=50 BAR_CHAR_START="[" BAR_CHAR_END="]" BAR_CHAR_EMPTY="." BAR_CHAR_FULL="=" BRACKET_CHARS=2 LIMIT=100 print_progress_bar() { # Calculate how many characters will be full. let "full_limit = ((($1 - $BRACKET_CHARS) * $2) / $LIMIT)" # Calculate how many characters will be empty. let "empty_limit = ($1 - $BRACKET_CHARS) - ${full_limit}" # Prepare the bar. bar_line="${BAR_CHAR_START}" for ((j=0; j<full_limit; j++)); do bar_line="${bar_line}${BAR_CHAR_FULL}" done for ((j=0; j<empty_limit; j++)); do bar_line="${bar_line}${BAR_CHAR_EMPTY}" done bar_line="${bar_line}${BAR_CHAR_END}" printf "%3d%% %s" $2 ${bar_line} } # Here is a sample of code that uses it. MAX_PERCENT=100 for ((i=0; i<=MAX_PERCENT; i++)); do # usleep 10000 # ... Or run some other commands ... # print_progress_bar ${BAR_WIDTH} ${i} echo -en "\r" done echo "" exit |
if-test 结构的特别巧妙的用法是用于注释块。
#!/bin/bash COMMENT_BLOCK= # Try setting the above variable to some value #+ for an unpleasant surprise. if [ $COMMENT_BLOCK ]; then Comment block -- ================================= This is a comment line. This is another comment line. This is yet another comment line. ================================= echo "This will not echo." Comment blocks are error-free! Whee! fi echo "No more comments, please." exit 0 |
将其与使用 here 文档注释掉代码块进行比较。
使用 $? 退出状态变量,脚本可以测试参数是否仅包含数字,以便可以将其视为整数。
#!/bin/bash SUCCESS=0 E_BADINPUT=85 test "$1" -ne 0 -o "$1" -eq 0 2>/dev/null # An integer is either equal to 0 or not equal to 0. # 2>/dev/null suppresses error message. if [ $? -ne "$SUCCESS" ] then echo "Usage: `basename $0` integer-input" exit $E_BADINPUT fi let "sum = $1 + 25" # Would give error if $1 not integer. echo "Sum = $sum" # Any variable, not just a command-line parameter, can be tested this way. exit 0 |
函数返回值的 0 - 255 范围是一个严重的限制。全局变量和其他解决方法通常存在问题。函数将值传回脚本主体的另一种方法是让函数写入stdout(通常使用 echo)“返回值”,并将此值分配给变量。这实际上是命令替换的一种变体。
示例 36-18. 返回值技巧
#!/bin/bash # multiplication.sh multiply () # Multiplies params passed. { # Will accept a variable number of args. local product=1 until [ -z "$1" ] # Until uses up arguments passed... do let "product *= $1" shift done echo $product # Will not echo to stdout, } #+ since this will be assigned to a variable. mult1=15383; mult2=25211 val1=`multiply $mult1 $mult2` # Assigns stdout (echo) of function to the variable val1. echo "$mult1 X $mult2 = $val1" # 387820813 mult1=25; mult2=5; mult3=20 val2=`multiply $mult1 $mult2 $mult3` echo "$mult1 X $mult2 X $mult3 = $val2" # 2500 mult1=188; mult2=37; mult3=25; mult4=47 val3=`multiply $mult1 $mult2 $mult3 $mult4` echo "$mult1 X $mult2 X $mult3 X $mult4 = $val3" # 8173300 exit 0 |
相同的技术也适用于字母数字字符串。这意味着函数可以“返回”非数值。
capitalize_ichar () # Capitalizes initial character { #+ of argument string(s) passed. string0="$@" # Accepts multiple arguments. firstchar=${string0:0:1} # First character. string1=${string0:1} # Rest of string(s). FirstChar=`echo "$firstchar" | tr a-z A-Z` # Capitalize first character. echo "$FirstChar$string1" # Output to stdout. } newstring=`capitalize_ichar "every sentence should start with a capital letter."` echo "$newstring" # Every sentence should start with a capital letter. |
甚至函数可以使用此方法“返回”多个值。
示例 36-19. 更多返回值技巧
#!/bin/bash # sum-product.sh # A function may "return" more than one value. sum_and_product () # Calculates both sum and product of passed args. { echo $(( $1 + $2 )) $(( $1 * $2 )) # Echoes to stdout each calculated value, separated by space. } echo echo "Enter first number " read first echo echo "Enter second number " read second echo retval=`sum_and_product $first $second` # Assigns output of function. sum=`echo "$retval" | awk '{print $1}'` # Assigns first field. product=`echo "$retval" | awk '{print $2}'` # Assigns second field. echo "$first + $second = $sum" echo "$first * $second = $product" echo exit 0 |
我们技巧包中的下一个技巧是将 数组传递给 函数,然后“返回”数组回到脚本主体。
传递数组涉及使用 命令替换将数组的空格分隔的元素加载到变量中。从函数中获取作为“返回值”的数组使用先前提到过的策略,即在函数中 echoing 数组,然后调用命令替换和 ( ... ) 运算符将其分配给数组。
示例 36-20. 传递和返回数组
#!/bin/bash # array-function.sh: Passing an array to a function and ... # "returning" an array from a function Pass_Array () { local passed_array # Local variable! passed_array=( `echo "$1"` ) echo "${passed_array[@]}" # List all the elements of the new array #+ declared and set within the function. } original_array=( element1 element2 element3 element4 element5 ) echo echo "original_array = ${original_array[@]}" # List all elements of original array. # This is the trick that permits passing an array to a function. # ********************************** argument=`echo ${original_array[@]}` # ********************************** # Pack a variable #+ with all the space-separated elements of the original array. # # Attempting to just pass the array itself will not work. # This is the trick that allows grabbing an array as a "return value". # ***************************************** returned_array=( `Pass_Array "$argument"` ) # ***************************************** # Assign 'echoed' output of function to array variable. echo "returned_array = ${returned_array[@]}" echo "=============================================================" # Now, try it again, #+ attempting to access (list) the array from outside the function. Pass_Array "$argument" # The function itself lists the array, but ... #+ accessing the array from outside the function is forbidden. echo "Passed array (within function) = ${passed_array[@]}" # NULL VALUE since the array is a variable local to the function. echo ############################################ # And here is an even more explicit example: ret_array () { for element in {11..20} do echo "$element " # Echo individual elements done #+ of what will be assembled into an array. } arr=( $(ret_array) ) # Assemble into array. echo "Capturing array \"arr\" from function ret_array () ..." echo "Third element of array \"arr\" is ${arr[2]}." # 13 (zero-indexed) echo -n "Entire array is: " echo ${arr[@]} # 11 12 13 14 15 16 17 18 19 20 echo exit 0 # Nathan Coulter points out that passing arrays with elements containing #+ whitespace breaks this example. |
有关将数组传递给函数的更详细示例,请参见 示例 A-10。
使用 双括号结构,可以使用 C 风格的语法来设置和递增/递减变量,以及在 for 和 while 循环中。请参见 示例 11-13 和 示例 11-18。
在脚本开头设置 path 和 umask 使其更具可移植性——更可能在“外国”机器上运行,该机器的用户可能搞砸了$PATH和 umask。
#!/bin/bash PATH=/bin:/usr/bin:/usr/local/bin ; export PATH umask 022 # Files that the script creates will have 755 permission. # Thanks to Ian D. Allen, for this tip. |
一个有用的脚本编写技术是重复地将过滤器的输出(通过管道)反馈到同一个过滤器,但使用不同的参数和/或选项。特别适合这样做的是 tr 和 grep。
# From "wstrings.sh" example. wlist=`strings "$1" | tr A-Z a-z | tr '[:space:]' Z | \ tr -cs '[:alpha:]' Z | tr -s '\173-\377' Z | tr Z ' '` |
示例 36-21. 字谜的乐趣
#!/bin/bash # agram.sh: Playing games with anagrams. # Find anagrams of... LETTERSET=etaoinshrdlu FILTER='.......' # How many letters minimum? # 1234567 anagram "$LETTERSET" | # Find all anagrams of the letterset... grep "$FILTER" | # With at least 7 letters, grep '^is' | # starting with 'is' grep -v 's$' | # no plurals grep -v 'ed$' # no past tense verbs # Possible to add many combinations of conditions and filters. # Uses "anagram" utility #+ that is part of the author's "yawl" word list package. # http://ibiblio.org/pub/Linux/libs/yawl-0.3.2.tar.gz # http://bash.deta.in/yawl-0.3.2.tar.gz exit 0 # End of code. bash$ sh agram.sh islander isolate isolead isotheral # Exercises: # --------- # Modify this script to take the LETTERSET as a command-line parameter. # Parameterize the filters in lines 11 - 13 (as with $FILTER), #+ so that they can be specified by passing arguments to a function. # For a slightly different approach to anagramming, #+ see the agram2.sh script. |
使用 “匿名 here 文档”来注释掉代码块,以避免不得不使用 # 单独注释掉每一行。请参见 示例 19-11。
在依赖于可能未安装的命令的机器上运行脚本是危险的。使用 whatis 以避免潜在的问题。
CMD=command1 # First choice. PlanB=command2 # Fallback option. command_test=$(whatis "$CMD" | grep 'nothing appropriate') # If 'command1' not found on system , 'whatis' will return #+ "command1: nothing appropriate." # # A safer alternative is: # command_test=$(whereis "$CMD" | grep \/) # But then the sense of the following test would have to be reversed, #+ since the $command_test variable holds content only if #+ the $CMD exists on the system. # (Thanks, bojster.) if [[ -z "$command_test" ]] # Check whether command present. then $CMD option1 option2 # Run command1 with options. else # Otherwise, $PlanB #+ run command2. fi |
if-grep 测试在错误情况下可能不会返回预期的结果,此时文本输出到stderr,而不是stdout.
if ls -l nonexistent_filename | grep -q 'No such file or directory' then echo "File \"nonexistent_filename\" does not exist." fi |
重定向 stderr到stdout修复了这个问题。
if ls -l nonexistent_filename 2>&1 | grep -q 'No such file or directory' # ^^^^ then echo "File \"nonexistent_filename\" does not exist." fi # Thanks, Chris Martin, for pointing this out. |
如果您绝对必须访问子 shell 外部的子 shell 变量,这是一种方法。
TMPFILE=tmpfile # Create a temp file to store the variable. ( # Inside the subshell ... inner_variable=Inner echo $inner_variable echo $inner_variable >>$TMPFILE # Append to temp file. ) # Outside the subshell ... echo; echo "-----"; echo echo $inner_variable # Null, as expected. echo "-----"; echo # Now ... read inner_variable <$TMPFILE # Read back shell variable. rm -f "$TMPFILE" # Get rid of temp file. echo "$inner_variable" # It's an ugly kludge, but it works. |
为了对复杂脚本进行多次修订,请使用 rcs 修订控制系统软件包。
这样做的好处之一是自动更新的 ID 标头标签。rcs 中的 co 命令执行某些保留关键字的参数替换,例如,替换# $Id$在脚本中,类似于
# $Id: hello-world.sh,v 1.1 2004/10/16 02:43:05 bozo Exp $ |
如果能够从 shell 脚本调用 X-Windows 组件就好了。碰巧存在几个声称可以做到这一点的软件包,即 Xscript、Xmenu 和 widtools。前两个似乎不再维护。幸运的是,仍然可以在这里获取 widtools。
![]() | widtools(组件工具)软件包需要安装 XForms 库。此外,在典型的 Linux 系统上构建软件包之前,需要对 Makefile 进行一些明智的编辑。最后,提供的六个组件中有三个不起作用(实际上,会段错误)。 |
dialog 工具系列提供了一种从 shell 脚本调用“dialog”组件的方法。原始的 dialog 实用程序在文本控制台中工作,但其后继者 gdialog、Xdialog 和 kdialog 使用基于 X-Windows 的组件集。
示例 36-22. 从 shell 脚本调用的组件
#!/bin/bash # dialog.sh: Using 'gdialog' widgets. # Must have 'gdialog' installed on your system to run this script. # Or, you can replace all instance of 'gdialog' below with 'kdialog' ... # Version 1.1 (corrected 04/05/05) # This script was inspired by the following article. # "Scripting for X Productivity," by Marco Fioretti, # LINUX JOURNAL, Issue 113, September 2003, pp. 86-9. # Thank you, all you good people at LJ. # Input error in dialog box. E_INPUT=85 # Dimensions of display, input widgets. HEIGHT=50 WIDTH=60 # Output file name (constructed out of script name). OUTFILE=$0.output # Display this script in a text widget. gdialog --title "Displaying: $0" --textbox $0 $HEIGHT $WIDTH # Now, we'll try saving input in a file. echo -n "VARIABLE=" > $OUTFILE gdialog --title "User Input" --inputbox "Enter variable, please:" \ $HEIGHT $WIDTH 2>> $OUTFILE if [ "$?" -eq 0 ] # It's good practice to check exit status. then echo "Executed \"dialog box\" without errors." else echo "Error(s) in \"dialog box\" execution." # Or, clicked on "Cancel", instead of "OK" button. rm $OUTFILE exit $E_INPUT fi # Now, we'll retrieve and display the saved variable. . $OUTFILE # 'Source' the saved file. echo "The variable input in the \"input box\" was: "$VARIABLE"" rm $OUTFILE # Clean up by removing the temp file. # Some applications may need to retain this file. exit $? # Exercise: Rewrite this script using the 'zenity' widget set. |
xmessage 命令是弹出一个消息/查询窗口的简单方法。例如
xmessage Fatal error in script! -button exit |
组件竞赛中的最新条目是 zenity。此实用程序弹出 GTK+ 对话框组件和窗口,并且在脚本中运行良好。
get_info () { zenity --entry # Pops up query window . . . #+ and prints user entry to stdout. # Also try the --calendar and --scale options. } answer=$( get_info ) # Capture stdout in $answer variable. echo "User entered: "$answer"" |
有关使用组件进行脚本编写的其他方法,请尝试 Tk 或 wish(Tcl 衍生品)、PerlTk(带有 Tk 扩展的 Perl)、tksh(带有 Tk 扩展的 ksh)、XForms4Perl(带有 XForms 扩展的 Perl)、Gtk-Perl(带有 Gtk 扩展的 Perl)或 PyQt(带有 Qt 扩展的 Python)。